# AttributeType.Hierarchy.DefaultHierarchy (ARX Developer Documentation)

org.deidentifier.arx

## Class AttributeType.Hierarchy.DefaultHierarchy

- java.lang.Object
- - org.deidentifier.arx.AttributeType
  - - org.deidentifier.arx.AttributeType.Hierarchy
    - - org.deidentifier.arx.AttributeType.Hierarchy.DefaultHierarchy

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable
  Enclosing class:
    AttributeType.Hierarchy

      public static class AttributeType.Hierarchy.DefaultHierarchy
      extends AttributeType.Hierarchy

  The default implementation of a generalization hierarchy. It allows the user to programmatically define its content.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.deidentifier.arx.AttributeType.Hierarchy

      `AttributeType.Hierarchy.DefaultHierarchy`

    - ### Nested classes/interfaces inherited from class org.deidentifier.arx.AttributeType

      `AttributeType.Hierarchy, AttributeType.MicroAggregationFunction, AttributeType.MicroAggregationFunctionDescription`

  - ### Field Summary

    - ### Fields inherited from class org.deidentifier.arx.AttributeType

      `ATTR_TYPE_ID, ATTR_TYPE_IS, ATTR_TYPE_QI, ATTR_TYPE_SE, IDENTIFYING_ATTRIBUTE, INSENSITIVE_ATTRIBUTE, MASK, QUASI_IDENTIFYING_ATTRIBUTE, SENSITIVE_ATTRIBUTE, SHIFT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AttributeType.Hierarchy.DefaultHierarchy()` Instantiates a new default hierarchy.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(java.lang.String... row)` Adds a row to the tabular representation of this hierarchy.
    `AttributeType.Hierarchy` | `clone()`
    `java.lang.String[][]` | `getHierarchy()` Returns the hierarchy as a two-dimensional string array.

    - ### Methods inherited from class org.deidentifier.arx.AttributeType.Hierarchy

      `create, create, create, create, create, create, create, create, create, create, create, create, create, create, create, create, create, create, save, save, save, save, save, save, save, save, save`

    - ### Methods inherited from class org.deidentifier.arx.AttributeType

      `getType, listMicroAggregationFunctions, toString`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AttributeType.Hierarchy.DefaultHierarchy

          public AttributeType.Hierarchy.DefaultHierarchy()

      Instantiates a new default hierarchy.

  - ### Method Detail

    - #### add

          public void add(java.lang.String... row)

      Adds a row to the tabular representation of this hierarchy.
      Parameters:
        `row` - the row

    - #### clone

          public AttributeType.Hierarchy clone()

      Specified by:
        `clone` in class `AttributeType.Hierarchy`

    - #### getHierarchy

          public java.lang.String[][] getHierarchy()

      Description copied from class: `AttributeType.Hierarchy`
      Returns the hierarchy as a two-dimensional string array.
      Specified by:
        `getHierarchy` in class `AttributeType.Hierarchy`
      Returns:
        the hierarchy